## fiat-ecmwf 1.6.1

=== CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
# (C) Copyright 2024- Meteo-France.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

project( fiat LANGUAGES Fortran C CXX )
include( fiat_macros )
ecbuild_enable_fortran( REQUIRED NO_MODULE_DIRECTORY )

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED TRUE)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

### Options

ecbuild_add_option( FEATURE OMP
                    DESCRIPTION "Support for OpenMP shared memory parallelism"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS Fortran" )

ecbuild_add_option( FEATURE MPI
                    DESCRIPTION "Support for MPI distributed parallelism"
                    REQUIRED_PACKAGES "MPI COMPONENTS Fortran" )

ecbuild_add_option( FEATURE DR_HOOK_PAPI
                    DESCRIPTION "Support for HW counters in DR_HOOK via PAPI"
                    REQUIRED_PACKAGES "PAPI")

ecbuild_find_package( fckit QUIET )
ecbuild_add_option( FEATURE FCKIT
                    DESCRIPTION "Support for fckit"
                    CONDITION fckit_FOUND AND fckit_HAVE_ECKIT )

ecbuild_add_option( FEATURE DR_HOOK_MULTI_PRECISION_HANDLES
                    DESCRIPTION "[DEPRECATED] Support single precision handles for DR_HOOK"
                    DEFAULT OFF )

ecbuild_add_option( FEATURE DOUBLE_PRECISION
                    DEFAULT ON
                    DESCRIPTION "Support for Double Precision" )

ecbuild_add_option( FEATURE SINGLE_PRECISION
                    DEFAULT ON
                    DESCRIPTION "Support for Single Precision" )

ecbuild_add_option( FEATURE DUMMY_MPI_HEADER
                    DEFAULT ON
                    DESCRIPTION "[DANGEROUS] Install a dummy MPI header" )

ecbuild_add_option( FEATURE WARNINGS
                    DEFAULT ON
                    DESCRIPTION "Add warnings to compiler" )

if(CMAKE_C_COMPILER_ID STREQUAL "PGI" OR CMAKE_C_COMPILER_ID STREQUAL "NVHPC" )
    set (DEFAULT_DR_HOOK_NVTX ON)
else()
    set (DEFAULT_DR_HOOK_NVTX OFF)
endif()
ecbuild_add_option( FEATURE DR_HOOK_NVTX
                    DEFAULT ${DEFAULT_DR_HOOK_NVTX}
                    DESCRIPTION "Support for NVTX in DR_HOOK"
                    REQUIRED_PACKAGES NVTX )

set (DEFAULT_DR_HOOK_ROCTX OFF)
ecbuild_add_option( FEATURE DR_HOOK_ROCTX
                    DEFAULT ${DEFAULT_DR_HOOK_ROCTX}
                    DESCRIPTION "Support for ROCTX in DR_HOOK"
                    REQUIRED_PACKAGES ROCTX )

ecbuild_find_package( NAME Realtime QUIET )

### Sources

include( fiat_compiler_warnings )
add_subdirectory(src)
add_subdirectory(share)

### Tests

add_subdirectory(tests)

### Export

ecbuild_install_project( NAME fiat )

ecbuild_print_summary()

=== share/CMakeLists.txt ===
add_subdirectory(fiat)

=== tests/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

if( HAVE_TESTS )

set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )

if( HAVE_MPI AND MPIEXEC )
  set (MPI_OPTS "" CACHE STRING "system depended srun or mpirun options (partition, time, account, ...)")
  set( LAUNCH ${MPIEXEC} ${MPI_OPTS} ${MPIEXEC_NUMPROC_FLAG} 1 )
else()
  set( LAUNCH ${CMAKE_CROSSCOMPILING_EMULATOR} )
endif()


if( HAVE_OMP )
  set( OMP OpenMP::OpenMP_Fortran )
endif()

if( HAVE_FCKIT )
  list( APPEND FCKIT_DEFINITIONS WITH_FCKIT )
  list( APPEND FCKIT_LIB fckit )
endif()

if( HAVE_FCKIT AND fckit_VERSION VERSION_GREATER_EQUAL 0.9.1 )
ecbuild_add_executable(
  TARGET  fiat-test-abort-exception-handler
  SOURCES test_abort_exception_handler.F90 test_abort_exception_handler.cc 
  LIBS    fiat fckit
  LINKER_LANGUAGE Fortran
  NOINSTALL)
add_test(NAME fiat_test_abort_exception_handler
  COMMAND ${CMAKE_COMMAND}
  "-DEXECUTABLE=$<TARGET_FILE:fiat-test-abort-exception-handler>"
  "-DLAUNCH=${LAUNCH}"
  "-DPASS_REGULAR_EXPRESSION=problem in function_2"
  -P ${CMAKE_CURRENT_SOURCE_DIR}/test_program_output.cmake )
endif()

add_subdirectory( drhook )

# ----------------------------------------------------------------------------------------
# Test: fiat_test_drhook_no_output
#
# Ensures that no output is generated with DR_HOOK_SILENT=1

ecbuild_add_executable(
    TARGET  fiat-test-drhook-no-output
    SOURCES test_drhook_no_output.c 
    LIBS    fiat
    LINKER_LANGUAGE C
    NOINSTALL )
add_test( NAME fiat_test_drhook_no_output
          COMMAND ${CMAKE_COMMAND}
          "-DLAUNCH=${LAUNCH}"
          "-DEXECUTABLE=$<TARGET_FILE:fiat-test-drhook-no-output>"
          -P ${CMAKE_CURRENT_SOURCE_DIR}/test_drhook_no_output.cmake )
set_tests_properties(fiat_test_drhook_no_output PROPERTIES
    ENVIRONMENT "DR_HOOK_ASSERT_MPI_INITIALIZED=0"
)


# ----------------------------------------------------------------------------------------
# Tests: fiat_test_drhook_abort_my_abort, fiat_test_drhook_abort_abor1fl
#
# Test that we can use drhook within C and register a custom abort

ecbuild_add_executable(
    TARGET  fiat-test-drhook-abort
    SOURCES test_drhook_abort.c
    LIBS    fiat
    LINKER_LANGUAGE C
    NOINSTALL )


add_test( NAME fiat_test_drhook_abort_abor1fl
          COMMAND fiat-test-drhook-abort )
set_tests_properties(fiat_test_drhook_abort_abor1fl PROPERTIES
    ENVIRONMENT "DR_HOOK_ASSERT_MPI_INITIALIZED=0"
    PASS_REGULAR_EXPRESSION "ABOR1.*EC_DRHOOK.*\[DrHookCallTree\]"
)

add_test( NAME fiat_test_drhook_abort_custom_abort
          COMMAND fiat-test-drhook-abort )
set_tests_properties(fiat_test_drhook_abort_custom_abort PROPERTIES
    ENVIRONMENT "CUSTOM_ABORT=1;DR_HOOK_ASSERT_MPI_INITIALIZED=0"
    PASS_REGULAR_EXPRESSION "custom_abort.*EC_DRHOOK.*\[DrHookCallTree\]"
)

# ----------------------------------------------------------------------------------------

ecbuild_add_test(
    TARGET  fiat_test_drhook_fortran
    SOURCES test_drhook_fortran.F90 
    LIBS    fiat ${OMP} ${FCKIT_LIB}
    LINKER_LANGUAGE Fortran
    DEFINITIONS ${FCKIT_DEFINITIONS})
set_tests_properties(fiat_test_drhook_fortran PROPERTIES
    ENVIRONMENT "MPL=0;DR_HOOK_ASSERT_MPI_INITIALIZED=0;DR_HOOK_OPT=NOPROPAGATE_SIGNALS"
    PASS_REGULAR_EXPRESSION "EC_DRHOOK.*\[DrHookCallTree\]" )


# ----------------------------------------------------------------------------------------
# Tests: fiat_test_drhook_counters

if( HAVE_DR_HOOK_PAPI )
  ecbuild_add_test(TARGET fiat_test_drhook_counters
    SOURCES test_drhook_counters.F90
            test_drhook_counters_stream.F90
            test_drhook_counters_gemm.F90
    LIBS    fiat
    ENVIRONMENT "DR_HOOK_ASSERT_MPI_INITIALIZED=0;FIAT_UNIT_TEST=1"
    )
  target_compile_definitions( fiat_test_drhook_counters PRIVATE OMP )
  if( NOT HAVE_MPI )
    target_compile_definitions( fiat_test_drhook_counters PRIVATE NOMPI )
  endif()

  if( CMAKE_Fortran_COMPILER_ID MATCHES Intel )
    set_source_files_properties(test_drhook_counters_stream.F90
      PROPERTIES COMPILE_OPTIONS "-qopt-prefetch-distance=64,12;-qopt-streaming-cache-evict=0;-qopt-streaming-stores always;-qopt-zmm-usage=high")
  endif()

  find_package( OpenMP COMPONENTS Fortran )
  if( TARGET OpenMP::OpenMP_Fortran )
    target_link_libraries( fiat_test_drhook_counters OpenMP::OpenMP_Fortran )
  endif()
  if( NOT BLAS_LIBRARIES )
    find_package( MKL QUIET )
    if( MKL_LIBRARIES )
      set( BLAS_LIBRARIES ${MKL_LIBRARIES} )
    else()
      find_package( BLAS QUIET )
    endif()
  endif()
  if( BLAS_LIBRARIES )
    target_link_libraries( fiat_test_drhook_counters ${BLAS_LIBRARIES} )
    target_compile_definitions( fiat_test_drhook_counters PUBLIC HAVE_BLAS )
  endif()
endif()

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_ec_args_fortran

ecbuild_add_test(
    TARGET  fiat_test_ec_args_fortran 
    SOURCES test_ec_args_fortran.F90 
    ARGS arg1 arg2 arg3
    LIBS    fiat ${OMP}
    LINKER_LANGUAGE Fortran )

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_bytes_io

ecbuild_add_test(
    TARGET  fiat_test_bytes_io 
    SOURCES test_bytes_io.F90 
    LIBS    fiat
    LINKER_LANGUAGE Fortran )

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_byteswap

ecbuild_add_test(
    TARGET  fiat_test_byteswap
    SOURCES test_byteswap.F90
    LIBS    fiat
    LINKER_LANGUAGE Fortran )

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_checksum_c

ecbuild_add_test(
    TARGET  fiat_test_checksum_c 
    SOURCES test_checksum.c
    LIBS    fiat )

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_checksum

ecbuild_add_test(
    TARGET  fiat_test_checksum
    SOURCES test_checksum.F90
    LIBS    fiat
    LINKER_LANGUAGE Fortran )

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_mpl_no_output
#   ensures that no output is generated in this test upon mpl_init() and mpl_end()

ecbuild_add_executable(
    TARGET  fiat-test-mpl-no-output
    SOURCES test_mpl_no_output.F90 
    LIBS    fiat
    LINKER_LANGUAGE Fortran
    NOINSTALL )

add_test(NAME fiat_test_mpl_no_output
         COMMAND ${CMAKE_COMMAND}
         "-DEXECUTABLE=$<TARGET_FILE:fiat-test-mpl-no-output>"
         "-DLAUNCH=${LAUNCH}"
         -P ${CMAKE_CURRENT_SOURCE_DIR}/test_mpl_no_output.cmake )

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_abor1
#
# Test abor1 function, and check the error message is printed

ecbuild_add_executable(
    TARGET  fiat-test-abor1
    SOURCES test_abor1.F90 
    LIBS    fiat ${OMP}
    LINKER_LANGUAGE Fortran
    NOINSTALL )
add_test(NAME fiat_test_abor1
      COMMAND ${CMAKE_COMMAND}
      "-DEXECUTABLE=$<TARGET_FILE:fiat-test-abor1>"
      "-DPASS_REGULAR_EXPRESSION=ABOR1.*aborting from OpenMP parallel region"
      -P ${CMAKE_CURRENT_SOURCE_DIR}/test_program_output.cmake )

#-----------------------------------------------------------------------------------------
# Tests:  fiat_test_alltoallv
#
#
ecbuild_add_test( TARGET fiat_test_alltoallv
    SOURCES alltoallv.F90
    LIBS     fiat
    LINKER_LANGUAGE Fortran
    MPI 2)
#-----------------------------------------------------------------------------------------
# Tests:  fiat_test_gatherv
#
#
ecbuild_add_test( TARGET fiat_test_gatherv
    SOURCES gatherv.F90 
    LIBS    fiat
    LINKER_LANGUAGE Fortran
    MPI 2)
#-----------------------------------------------------------------------------------------
# Tests:  fiat_test_allgatherv
#
#
ecbuild_add_test( TARGET fiat_test_allgatherv
    SOURCES allgatherv.F90 
    LIBS    fiat
    LINKER_LANGUAGE Fortran
    MPI 2)                  
#-----------------------------------------------------------------------------------------
# Tests:  fiat_test_scatterv
#
#
ecbuild_add_test( TARGET fiat_test_scatterv
    SOURCES scatterv.F90 
    LIBS    fiat
    LINKER_LANGUAGE Fortran
    MPI 2)
#-----------------------------------------------------------------------------------------
# Tests: fiat_test_displs_container
#
# test the linled_list needed for the non-blocking collectives 
ecbuild_add_test( TARGET fiat_test_displs_container
    SOURCES displs_container.F90
    LIBS    fiat
    LINKER_LANGUAGE Fortran)

# ----------------------------------------------------------------------------------------
# Tests: fiat_test_namelist

ecbuild_add_executable(
    TARGET  fiat_test_namelist
    SOURCES test_namelist.F90
    LIBS    fiat
    LINKER_LANGUAGE Fortran
    NOINSTALL )
add_test(NAME fiat_test_namelist
      COMMAND ${CMAKE_COMMAND}
      "-DEXECUTABLE=$<TARGET_FILE:fiat_test_namelist>"
      "-DPASS_REGULAR_EXPRESSION=ABOR1.*POSNAM:CANNOT LOCATE NAM_NONPRESENT"
      -P ${CMAKE_CURRENT_SOURCE_DIR}/test_program_output.cmake )

# ----------------------------------------------------------------------------------------
# Test installation of fiat is working

configure_file( test-install.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-install.sh @ONLY )

unset( _test_args )
if( CMAKE_TOOLCHAIN_FILE )
  list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
endif()
foreach( lang C CXX Fortran )
  if( CMAKE_${lang}_COMPILER )
    list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
  endif()
  if( CMAKE_${lang}_FLAGS )
    list( APPEND _test_args "-DCMAKE_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
  endif()
  if( CMAKE_EXE_LINKER_FLAGS )
    list( APPEND _test_args "-DCMAKE_EXE_LINKER_FLAGS=${CMAKE_EXE_LINKER_FLAGS}" )
  endif()
endforeach()

add_test( NAME fiat_test_install
          COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-install.sh ${_test_args} )

# ----------------------------------------------------------------------------------------

endif(HAVE_TESTS)

=== share/fiat/CMakeLists.txt ===
add_subdirectory(drhook)

=== src/fiat/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
# (C) Copyright 2024- Meteo-France.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

### Assemble list of definitions

if( HAVE_FCKIT )
  list( APPEND FIAT_DEFINITIONS WITH_FCKIT )
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  list( APPEND FIAT_DEFINITIONS LINUX )
endif()

if( HAVE_DR_HOOK_MULTI_PRECISION_HANDLES )
   list( APPEND FIAT_DEFINITIONS DR_HOOK_MULTI_PRECISION_HANDLES )
endif()

if( FIAT_ATTRIBUTE_CONSTRUCTOR_SUPPORTED )
  list( APPEND FIAT_DEFINITIONS FIAT_ATTRIBUTE_CONSTRUCTOR_SUPPORTED )
endif()

### Compilation flags

if( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  ## To disable checking of argument correctness of dummy mpi symbols
  ecbuild_add_fortran_flags( -nowarn nointerfaces NO_FAIL )
endif()

if( CMAKE_Fortran_COMPILER_ID MATCHES "GNU" )
  ecbuild_add_fortran_flags( -ffree-line-length-none NO_FAIL )
  if( CMAKE_Fortran_COMPILER_VERSION GREATER_EQUAL 10 )
      ecbuild_add_fortran_flags( -fallow-argument-mismatch NO_FAIL )
  endif()
endif()

if( NOT fiat_VERSION_PATCH )
    set( fiat_VERSION_PATCH 0 )
endif()
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/library/version.c.in ${CMAKE_CURRENT_BINARY_DIR}/version.c @ONLY )

ecbuild_list_add_pattern( LIST fiat_src GLOB *.c *.F* *.cc )

ecbuild_list_exclude_pattern( LIST fiat_src REGEX drhook/extensions/*)

set( fiat_src ${fiat_src} PARENT_SCOPE )

ecbuild_add_library( TARGET fiat
    LINKER_LANGUAGE Fortran
    SOURCES ${fiat_src} ${CMAKE_CURRENT_BINARY_DIR}/version.c
    PRIVATE_LIBS 
        ${CMAKE_DL_LIBS}
        ${RT_LIB}
    PRIVATE_INCLUDES
        ${CMAKE_CURRENT_SOURCE_DIR}/drhook/internal
        ${CMAKE_CURRENT_SOURCE_DIR}/ecsort/internal
        ${CMAKE_CURRENT_SOURCE_DIR}/util/internal
        ${CMAKE_CURRENT_SOURCE_DIR}/system/internal
    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/fiat>
        $<INSTALL_INTERFACE:include>
        $<INSTALL_INTERFACE:include/fiat>
)

if (HAVE_DR_HOOK_NVTX)
    # Files from within DrHook
    ecbuild_list_add_pattern( LIST fiat_nvtx_src GLOB *.c SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/drhook/extensions/nvtx)
    target_sources(fiat PRIVATE ${fiat_nvtx_src})
    target_include_directories(fiat PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/drhook/extensions/nvtx)
    target_compile_definitions(fiat PRIVATE DR_HOOK_HAVE_NVTX=1 HAVE_NVTX3=${HAVE_NVTX3} )

    # Link with NVTX
    target_link_libraries     (fiat PRIVATE ${NVTX_LIBRARIES})
    target_include_directories(fiat PRIVATE ${NVTX_INCLUDE_DIRS})
endif()

if (HAVE_DR_HOOK_ROCTX)
    # Files from within DrHook
    ecbuild_list_add_pattern( LIST fiat_roctx_src GLOB *.c SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/drhook/extensions/roctx)
    target_sources(fiat PRIVATE ${fiat_roctx_src})
    target_include_directories(fiat PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/drhook/extensions/roctx)
    target_compile_definitions(fiat PRIVATE DR_HOOK_HAVE_ROCTX=1 HAVE_ROCPROFILER_SDK_ROCTX=${HAVE_ROCPROFILER_SDK_ROCTX})

    # Link with ROCTX
    target_link_libraries     (fiat PRIVATE ${ROCTX_LIBRARIES})
    target_include_directories(fiat PRIVATE ${ROCTX_INCLUDE_DIRS})
endif()

if (HAVE_DR_HOOK_PAPI)
    # Files from within DrHook
    ecbuild_list_add_pattern( LIST fiat_papi_src GLOB *.c SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/drhook/extensions/papi)
    target_sources(fiat PRIVATE ${fiat_papi_src})
    target_include_directories(fiat PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/drhook/extensions/papi)
    target_compile_definitions(fiat PRIVATE DR_HOOK_HAVE_PAPI=1)

    # Files defined externally
    target_link_libraries      ( fiat PRIVATE ${PAPI_LIBRARIES} )
    target_include_directories ( fiat PRIVATE ${PAPI_INCLUDE_DIRS} )
endif()

if( ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" )
  # Following should not be necessary; 
  # Probably a bug in the M1 prerelease of gfortran 10.2.0.4
  target_compile_definitions( fiat PRIVATE $<$<COMPILE_LANG_AND_ID:Fortran,GNU>:__APPLE__>)
endif()

target_compile_definitions( fiat PRIVATE ${FIAT_DEFINITIONS} )

if( HAVE_FCKIT )
    target_link_libraries( fiat PRIVATE fckit )
endif()

if( HAVE_MPI )
    target_link_libraries( fiat PUBLIC ${MPI_Fortran_LIBRARIES} )
    target_include_directories( fiat PRIVATE ${MPI_Fortran_INCLUDE_DIRS} )
else()
    target_link_libraries( fiat PRIVATE  mpi_serial )
endif()

if( HAVE_OMP )
    target_link_libraries( fiat PRIVATE OpenMP::OpenMP_Fortran )
endif()

fiat_target_ignore_missing_symbols( TARGET fiat SYMBOLS
  _MallocExtension_GetNumericProperty
  _MPI_Get_version
  _MPI_Get_library_version
)

## Install and Export ##

execute_process( COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/include )
execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/include/fiat ${PROJECT_BINARY_DIR}/include/fiat )
install(
  DIRECTORY   ${CMAKE_CURRENT_SOURCE_DIR}/include/fiat
  DESTINATION include
)
install(
  FILES       ${CMAKE_CURRENT_SOURCE_DIR}/version.h
  DESTINATION include/fiat
)

fiat_target_fortran_module_directory(
  TARGET fiat
  MODULE_DIRECTORY  ${CMAKE_BINARY_DIR}/module/fiat
  INSTALL_DIRECTORY module/fiat
)

set( FIAT_DEFINITIONS ${FIAT_DEFINITIONS} PARENT_SCOPE )

=== src/mpi_serial/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

### mpi_serial library

ecbuild_add_library( TARGET mpi_serial
  TYPE STATIC
  SOURCES
            mpi_abort.F
            mpi_allgatherv.F
            mpi_allreduce.F
            mpi_alltoallv.F
            mpi_barrier.F
            mpi_bcast.F
            mpi_bsend.F
            mpi_buffer_attach.F
            mpi_buffer_detach.F
            mpi_cart_coords.F
            mpi_cart_create.F
            mpi_cart_rank.F
            mpi_cart_sub.F
            mpi_comm_compare.F
            mpi_comm_create.F
            mpi_comm_free.F
            mpi_comm_group.F
            mpi_comm_rank.F
            mpi_comm_size.F
            mpi_comm_split.F
            mpi_end.F
            mpi_error_string.F
            mpi_file_close.F
            mpi_file_iread_shared.F
            mpi_file_iwrite_shared.F
            mpi_file_open.F
            mpi_file_read_ordered.F
            mpi_file_read_ordered_begin.F
            mpi_file_read_ordered_end.F
            mpi_file_read_shared.F
            mpi_file_write_ordered.F
            mpi_file_write_ordered_begin.F
            mpi_file_write_ordered_end.F
            mpi_file_write_shared.F
            mpi_finalize.F
            mpi_finalized.F
            mpi_gather.F
            mpi_gatherv.F
            mpi_get_count.F
            mpi_group_free.F
            mpi_group_incl.F
            mpi_iallgatherv.F
            mpi_ialltoallv.F
            mpi_ibcast.F
            mpi_ibsend.F
            mpi_igather.F
            mpi_igatherv.F
            mpi_init.F
            mpi_init_thread.F
            mpi_initialized.F
            mpi_iprobe.F
            mpi_irecv.F
            mpi_iscatter.F
            mpi_iscatterv.F
            mpi_isend.F
            mpi_probe.F
            mpi_recv.F
            mpi_scatterv.F
            mpi_send.F
            mpi_ssend.F
            mpi_testsome.F
            mpi_type_size.F
            mpi_wait.F
            mpi_waitall.F
            mpi_waitany.F
            mpi_waitsome.F
            vpp_abort.F
            vpp_barrier.F
    PUBLIC_INCLUDES 
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
            $<INSTALL_INTERFACE:include/mpi_serial>
)

## Install and Export ##

install(DIRECTORY DESTINATION "include/mpi_serial")

if( ${HAVE_DUMMY_MPI_HEADER} )

  install(
      FILES
          ${CMAKE_CURRENT_SOURCE_DIR}/mpif.h
      DESTINATION
          include/mpi_serial
  )

endif()

=== src/parkind/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

set( HAVE_dp ${HAVE_DOUBLE_PRECISION} )
set( HAVE_sp ${HAVE_SINGLE_PRECISION} )

foreach( prec sp dp )
  if( HAVE_${prec} )
    set( target parkind_${prec} )
    ecbuild_add_library(
      TARGET  ${target}
      SOURCES parkind1.F90
              parkind2.F90
    )

    if( EC_OS_BITS EQUAL "64" )
      target_compile_definitions( ${target} PRIVATE ADDRESS64 )
    endif()

    fiat_target_fortran_module_directory(
      TARGET            ${target}
      MODULE_DIRECTORY  ${CMAKE_BINARY_DIR}/module/${target}
      INSTALL_DIRECTORY module/${target}
    )
  endif()
endforeach()

if( TARGET parkind_sp )
  target_compile_definitions( parkind_sp PRIVATE PARKIND1_SINGLE )
endif()

=== src/programs/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

### fiat information tool

set( tool fiat )

get_property( langs GLOBAL PROPERTY ENABLED_LANGUAGES )

foreach( lang ${langs} )
  set( EC_${lang}_FLAGS "${CMAKE_${lang}_FLAGS} ${CMAKE_${lang}_FLAGS_${CMAKE_BUILD_TYPE_CAPS}}" )
endforeach()

configure_file( ${tool}.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${tool} @ONLY )

file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${tool}
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install(
  FILES  ${CMAKE_BINARY_DIR}/bin/${tool}
  DESTINATION   ${INSTALL_BIN_DIR}
  PERMISSIONS   OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

### drhook-merge tool

list( APPEND files
  drhook-merge
)

install(
  FILES       ${files}
  DESTINATION ${INSTALL_BIN_DIR}
  PERMISSIONS   OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
foreach( file ${files} )
  execute_process(COMMAND "${CMAKE_COMMAND}" "-E" "create_symlink"
      "${CMAKE_CURRENT_SOURCE_DIR}/${file}"
      "${CMAKE_BINARY_DIR}/${INSTALL_BIN_DIR}/${file}")
endforeach()

### Program fiat-printbinding
# Note: it only depends on MPI and OpenMP
ecbuild_add_executable(TARGET fiat-printbinding
  SOURCES fiat-printbinding.c )
find_package( OpenMP COMPONENTS C )
if( TARGET OpenMP::OpenMP_C )
  target_link_libraries( fiat-printbinding OpenMP::OpenMP_C )
endif()

find_package( MPI COMPONENTS C )
if( HAVE_MPI AND TARGET MPI::MPI_C )
  target_link_libraries( fiat-printbinding MPI::MPI_C )
else()
  target_compile_definitions( fiat-printbinding PRIVATE NOMPI )
endif()

# On LUMI with Cray compiler we have false warnings about implicit function declaration (CPU_ZERO, sched_affinity)
check_c_compiler_flag( "-Wno-implicit-function-declaration" disable_warning_implicit_function_declaration )
if( disable_warning_implicit_function_declaration )
  target_compile_options( fiat-printbinding PRIVATE "-Wno-implicit-function-declaration" )
endif()

=== tests/drhook/CMakeLists.txt ===
find_package( CMath )

ecbuild_add_executable( TARGET drhook_ex1
  SOURCES drhook_ex1.F90 
  LIBS fiat
  LINKER_LANGUAGE Fortran
  NOINSTALL )

ecbuild_add_executable( TARGET drhook_ex2
  SOURCES drhook_ex2.F90 
  LIBS fiat
  LINKER_LANGUAGE Fortran
  NOINSTALL )

ecbuild_add_executable( TARGET drhook_ex3
  SOURCES drhook_ex3.F90 
  LIBS fiat
  LINKER_LANGUAGE Fortran
  NOINSTALL )

ecbuild_add_executable( TARGET drhook_ex4
  SOURCES drhook_ex4.c
  LIBS fiat ${CMATH_LIBRARIES}
  LINKER_LANGUAGE C
  NOINSTALL )
if( CMAKE_C_COMPILER_ID MATCHES "PGI|NVHPC" )
  target_compile_options( drhook_ex4 PUBLIC -Ktrap=fp )
endif()

ecbuild_add_executable( TARGET drhook_ex5
  SOURCES drhook_ex5.F90
  LIBS fiat
  LINKER_LANGUAGE Fortran
  NOINSTALL )


set( FPE_TRAPPING_SUPPORTED 1 )
if( APPLE )
  set( FPE_TRAPPING_SUPPORTED 0 )
endif()

# Test floating point trapping
ecbuild_add_test( TARGET fiat_test_drhook_ex1
                  COMMAND drhook_ex1
                  ENVIRONMENT DR_HOOK=1 DR_HOOK_TRAPFPE=1 DR_HOOK_ASSERT_MPI_INITIALIZED=0 DR_HOOK_OPT=NOPROPAGATE_SIGNALS )

if( FPE_TRAPPING_SUPPORTED )
  set_tests_properties( fiat_test_drhook_ex1 PROPERTIES WILL_FAIL TRUE )
endif()

# Test watchpoint point trapping
ecbuild_add_test( TARGET fiat_test_drhook_ex2
                  COMMAND drhook_ex2
                  ENVIRONMENT DR_HOOK=1 DR_HOOK_ASSERT_MPI_INITIALIZED=0 DR_HOOK_OPT=NOPROPAGATE_SIGNALS )
set_tests_properties( fiat_test_drhook_ex2 PROPERTIES WILL_FAIL TRUE )

# Play with profiling options
ecbuild_add_test( TARGET fiat_test_drhook_ex3
                  COMMAND drhook_ex3
                  ENVIRONMENT DR_HOOK=1 DR_HOOK_ASSERT_MPI_INITIALIZED=0 )

# Test floating point trapping from C program
ecbuild_add_test( TARGET fiat_test_drhook_ex4
                  COMMAND drhook_ex4
                  ENVIRONMENT DR_HOOK=1 SIGFPE=1 DR_HOOK_ASSERT_MPI_INITIALIZED=0 DR_HOOK_OPT=NOPROPAGATE_SIGNALS )
if( FPE_TRAPPING_SUPPORTED )
  set_tests_properties( fiat_test_drhook_ex4 PROPERTIES WILL_FAIL TRUE )
endif()

# Play MPI and dr_hook together
ecbuild_add_test( TARGET fiat_test_drhook_ex5
                  COMMAND drhook_ex5
                  MPI 2
                  ENVIRONMENT DR_HOOK=1 DR_HOOK_SILENT=1
                  CONDITION HAVE_MPI )

# TODO:
# Better parse output to see if it matches.

# ------------------------------------------------------------------------------
#  External Library Tests
# ------------------------------------------------------------------------------

# NVTX
if (HAVE_DR_HOOK_NVTX)
  add_subdirectory(drhook_nvtx)
endif ()

# ROCTX
if (HAVE_DR_HOOK_ROCTX)
  add_subdirectory(drhook_roctx)
endif ()

# PAPI
if (HAVE_DR_HOOK_PAPI)
  add_subdirectory(drhook_papi)
endif ()

=== tests/test_install/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
find_package( ecbuild 3.3 REQUIRED )
project( fiat_test_install VERSION 0.0.0 LANGUAGES Fortran )

find_package( fiat REQUIRED )

if( TARGET parkind_dp )
ecbuild_add_executable( TARGET  main_dp
                        SOURCES main.F90
                        LIBS    fiat parkind_dp )
endif()

if( TARGET parkind_sp )
ecbuild_add_executable( TARGET  main_sp
                        SOURCES main.F90
                        LIBS    fiat parkind_sp )
endif()

=== share/fiat/drhook/CMakeLists.txt ===
list( APPEND files
  drhook_merge_walltime.pl
  drhook_merge_walltime_max.pl
  drhook_merge_walltime_total_max.pl
)
set( destination share/fiat/drhook )

install(
    FILES       ${files}
    DESTINATION ${destination}
    PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${destination})

foreach( file ${files} )
  execute_process(COMMAND "${CMAKE_COMMAND}" "-E" "create_symlink"
      "${CMAKE_CURRENT_SOURCE_DIR}/${file}"
      "${CMAKE_BINARY_DIR}/${destination}/${file}")
endforeach()

=== tests/drhook/drhook_nvtx/CMakeLists.txt ===
#
# (C) Copyright 2024- ECMWF.
# (C) Copyright 2024- Meteo-France.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# Test basic implementation

ecbuild_add_executable( TARGET drhook_nvtx_basic
  SOURCES drhook_nvtx_basic.F90
  LIBS fiat
  LINKER_LANGUAGE Fortran
  CONDITION HAVE_DR_HOOK_NVTX
  NOINSTALL )

ecbuild_add_test( TARGET fiat_test_drhook_nvtx_basic
        TYPE SCRIPT
        COMMAND "nsys"
        ARGS "profile" "--force-overwrite=true" "--trace=nvtx" "--kill=none" "--output=nsys.drhook_nvtx_basic.qdrep" "./drhook_nvtx_basic"
        ENVIRONMENT DR_HOOK=1 DR_HOOK_NVTX=1
        CONDITION HAVE_DR_HOOK_NVTX )

# Test basic implementation in C

ecbuild_add_executable( TARGET drhook_nvtx_basic_c
  SOURCES drhook_nvtx_basic_c.c
  LIBS fiat
  LINKER_LANGUAGE C
  CONDITION HAVE_DR_HOOK_NVTX
  NOINSTALL )

ecbuild_add_test( TARGET fiat_test_drhook_nvtx_basic_c
        TYPE SCRIPT
        COMMAND "nsys"
        ARGS "profile" "--force-overwrite=true" "--trace=nvtx" "--kill=none" "--output=nsys.drhook_nvtx_basic_c.qdrep" "./drhook_nvtx_basic_c"
        ENVIRONMENT DR_HOOK=1 DR_HOOK_NVTX=1
        CONDITION HAVE_DR_HOOK_NVTX )

# Test abort on mismatched region names

ecbuild_add_executable( TARGET drhook_nvtx_mismatched_regions
        SOURCES drhook_nvtx_mismatched_regions.F90
        LIBS fiat
        LINKER_LANGUAGE Fortran
        CONDITION HAVE_DR_HOOK_NVTX
        NOINSTALL )

ecbuild_add_test( TARGET fiat_test_drhook_nvtx_mismatched_regions
        TYPE SCRIPT
        COMMAND "nsys"
        ARGS "profile" "--force-overwrite=true" "--trace=nvtx" "--kill=none" "--output=nsys.drhook_nvtx_mismatched_regions.qdrep" "./drhook_nvtx_mismatched_regions"
        ENVIRONMENT DR_HOOK=1 DR_HOOK_NVTX=1
        CONDITION HAVE_DR_HOOK_NVTX )

if (TEST fiat_test_drhook_nvtx_mismatched_regions)
    set_tests_properties(fiat_test_drhook_nvtx_mismatched_regions
            PROPERTIES WILL_FAIL TRUE )
endif()

# Test skip on spammy regions

ecbuild_add_executable( TARGET drhook_nvtx_skip_spam_regions
        SOURCES drhook_nvtx_skip_spam_regions.F90
        LIBS fiat
        LINKER_LANGUAGE Fortran
        CONDITION HAVE_DR_HOOK_NVTX
        NOINSTALL )

ecbuild_add_test( TARGET fiat_test_drhook_nvtx_skip_spam_regions
        TYPE SCRIPT
        COMMAND "nsys"
        ARGS "profile" "--force-overwrite=true" "--trace=nvtx" "--kill=none" "--output=nsys.drhook_nvtx_skip_spam_regions.qdrep" "./drhook_nvtx_skip_spam_regions"
        ENVIRONMENT DR_HOOK=1 DR_HOOK_NVTX=1 DR_HOOK_SILENT=0
        CONDITION HAVE_DR_HOOK_NVTX )

if (TEST fiat_test_drhook_nvtx_skip_spam_regions)
    set_tests_properties(fiat_test_drhook_nvtx_skip_spam_regions
            PROPERTIES PASS_REGULAR_EXPRESSION "DRHOOK:NVTX: Skipping closing of region foo" PASS_REGULAR_EXPRESSION "DRHOOK:NVTX: Skipping opening of region foo" )
endif()

# Test not to skip on spammy regions with long runtimes

ecbuild_add_executable( TARGET drhook_nvtx_no_skip_spam_regions
        SOURCES drhook_nvtx_no_skip_spam_regions.F90
        LIBS fiat
        LINKER_LANGUAGE Fortran
        CONDITION HAVE_DR_HOOK_NVTX
        NOINSTALL )

ecbuild_add_test( TARGET fiat_test_drhook_nvtx_no_skip_spam_regions
        TYPE SCRIPT
        COMMAND "nsys"
        ARGS "profile" "--force-overwrite=true" "--trace=nvtx" "--kill=none" "--output=nsys.drhook_nvtx_no_skip_spam_regions.qdrep" "./drhook_nvtx_no_skip_spam_regions"
        ENVIRONMENT DR_HOOK=1 DR_HOOK_NVTX=1 DR_HOOK_SILENT=0
        CONDITION HAVE_DR_HOOK_NVTX )

if (TEST fiat_test_drhook_nvtx_no_skip_spam_regions)
    set_tests_properties(fiat_test_drhook_nvtx_no_skip_spam_regions
            PROPERTIES FAIL_REGULAR_EXPRESSION "DRHOOK:NVTX: Skipping closing of region foo" FAIL_REGULAR_EXPRESSION "DRHOOK:NVTX: Skipping opening of region foo" )
endif()

=== debian/changelog ===
fiat-ecmwf (1.6.1-1) unstable; urgency=medium

  * Drop B-D on dh-buildinfo
  * New upstream release
  * Add d/watch file
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Aug 2025 16:35:22 +0100

=== debian/control ===
Source: fiat-ecmwf
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.3.2),
  python3-all-dev,
  libfckit-dev (>= 0.11.0-5),
  libfckit-utils,
  mpi-default-dev,
  chrpath
Standards-Version: 4.7.2
Homepage: https://github.com/ecmwf-ifs/fiat
Vcs-Browser: https://salsa.debian.org/science-team/fiat.git
Vcs-Git: https://salsa.debian.org/science-team/fiat.git -b debian/latest

Package: libfiat-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fortran IFS and Arpege Toolkit - libray
 FIAT is a collection of selected Fortran utility libraries, extracted from 
 the IFS/Arpege model used at ECMWF.
 It provides:
   drhook : tracing
   gstats : timing
   parkind : choose precision
   mpl : MPI communication
   mpi_serial: MPI dummy symbols compiled into static library other 
               various routines
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.


Package: fiat-utils
Architecture: any
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libfiat-0 (= ${binary:Version}) 
Description: Fortran IFS and Arpege Toolkit - utilities
 FIAT is a collection of selected Fortran utility libraries, extracted from 
 the IFS/Arpege model used at ECMWF.
 It provides:
   drhook : tracing
   gstats : timing
   parkind : choose precision
   mpl : MPI communication
   mpi_serial: MPI dummy symbols compiled into static library other 
               various routines
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfiat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: ecbuild, ${fortran:Recommends}
Depends:  ${misc:Depends}, ${fortran:Depends},
 libfiat-0 (= ${binary:Version}),
 fiat-utils (= ${binary:Version}),
 libfckit-dev
Description: Fortran IFS and Arpege Toolkit - development files
 FIAT is a collection of selected Fortran utility libraries, extracted from 
 the IFS/Arpege model used at ECMWF.
 It provides:
   drhook : tracing
   gstats : timing
   parkind : choose precision
   mpl : MPI communication
   mpi_serial: MPI dummy symbols compiled into static library other 
               various routines
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/watch ===
version=4
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf-ifs/fiat/tags .*/v?(\d\d?\d?\..+).tar\.gz

## fiat-ecmwf 1.6.2

=== debian/changelog ===
fiat-ecmwf (1.6.2-2) unstable; urgency=medium

  * Now use dh_fortran get_fmoddir
  * Move from dh-fortran-mod to dh-fortran

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Dec 2025 17:00:46 +0000

fiat-ecmwf (1.6.2-1) unstable; urgency=medium

  * Upstream release 1.6.2
  * Change vcs-browser to canonical form
  * Update d/copyright to match licenserecon

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Dec 2025 07:49:16 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
-  dh-fortran-mod (>= 0.31),
+  dh-fortran (>= 0.50),
   ecbuild (>= 3.3.2),
   python3-all-dev,
   libfckit-dev (>= 0.11.0-5),
@@ -14,7 +14,7 @@
   chrpath
 Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf-ifs/fiat
-Vcs-Browser: https://salsa.debian.org/science-team/fiat.git
+Vcs-Browser: https://salsa.debian.org/science-team/fiat
 Vcs-Git: https://salsa.debian.org/science-team/fiat.git -b debian/latest
 
 Package: libfiat-0

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
FMODDIR:=$(shell dh_fortran get_fmoddir)
INSTDIR:=$(CURDIR)/debian/tmp
CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake

export FIAT_TEST_IGNORE_MPI_OUTPUT=1

DEB_CFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
DEB_CXXFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
DEB_FFLAGS_MAINT_APPEND= -I$(FMODDIR)
include /usr/share/dpkg/buildflags.mk


# OMP Doesn't appear to work on these archs
ARCH_NO_OMP:= riscv64 sparc64
ENABLE_OMP:=  $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NO_OMP)),Off,On)

BUILD_FLAGS = \
	-DENABLE_DOCS=On \
	-DENABLE_OMP=$(ENABLE_OMP) \
	-DENABLE_FORTRAN=On \
	-DENABLE_FCKIT=On \
	-DENABLE_MPI=On 

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=ecbuild --builddir=debian/build --with fortran

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test || true
endif

override_dh_auto_install:
	dh_auto_install
	chrpath -d $(INSTDIR)/usr/bin/fiat-printbinding
	chrpath -d $(INSTDIR)/$(LIBDIR)/*.so*
	# Fix broken paths
	sed -i -e 's%$${_IMPORT_PREFIX}/include/fiat%/usr/include/${DEB_HOST_MULTIARCH}/fiat%g' \
		-e 's%$${_IMPORT_PREFIX}/include/mpi_serial%/usr/include/${DEB_HOST_MULTIARCH}/mpi_serial%g' \
		-e 's%$${_IMPORT_PREFIX}/module/fiat%${FMODDIR}/fiat%g' \
		-e 's%$${_IMPORT_PREFIX}/module/parkind_dp%${FMODDIR}/parkind_dp%g' \
		-e 's%$${_IMPORT_PREFIX}/module/parkind_sp%${FMODDIR}/parkind_sp%g' \
		$(CMAKE_DIR)/fiat/fiat-targets.cmake
